/*
 * Jarapac DCE/RPC Framework
 * 
 * Copyright (C) 2008 StillSecure www.stillsecure.com
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * Class: lsarpc.java
 * 
 * Author: Joe Webster
 * 
 * Description: provides lsarpc (Local Security Authority) services.
 * 
 */
package msrpc;

import rpc.*;
import ndr.*;

/**
 * This class was originally generated via the midlc compiler from IDL code
 * provided with Jarapac and Samba 4.0.0tp4. It has been significantly altered
 * for for this implementation.
 * 
 * @author Joe Webster
 * 
 */
public class lsarpc extends Stub {

	public static final String MY_SYNTAX = "12345778-1234-abcd-ef00-0123456789ab:0.0";

	public String getSyntax() {
		return MY_SYNTAX;
	}

	/**
	 * lsarpc pipe defines
	 */
	public static final int LSA_CLOSE = 0x00;
	public static final int LSA_DELETE = 0x01;
	public static final int LSA_ENUM_PRIVS = 0x02;
	public static final int LSA_QUERY_SEC_OBJ = 0x03;
	public static final int LSA_SET_SEC_OBJ = 0x04;
	public static final int LSA_CHANGE_PASSWORD = 0x05;
	public static final int LSA_OPEN_POLICY = 0x06;
	public static final int LSA_QUERY_INFO_POLICY = 0x07;
	public static final int LSA_SET_INFO_POLICY = 0x08;
	public static final int LSA_CLR_AUDIT_LOG = 0x09;
	public static final int LSA_CREATE_ACCT = 0x0A;
	public static final int LSA_ENUM_ACCTS = 0x0B;
	public static final int LSA_CREATE_TRUSTED_DOMAIN = 0x0C;
	public static final int LSA_ENUM_TRUSTED_DOMAINS = 0x0D;
	public static final int LSA_LOOKUP_NAMES = 0x0E;
	public static final int LSA_LOOKUP_SIDS = 0x0F;
	public static final int LSA_CREATE_SECRET = 0x10;
	public static final int LSA_OPEN_ACCOUNT = 0x11;
	public static final int LSA_ENUM_PRIVS_ACCOUNT = 0x12;
	public static final int LSA_ADD_PRIVS_TO_ACCOUNT = 0x13;
	public static final int LSA_REM_PRIVS_FROM_ACCOUNT = 0x14;
	public static final int LSA_GET_QUOTAS_FOR_ACCOUNT = 0x15;
	public static final int LSA_SET_QUOTAS_FOR_ACCOUNT = 0x16;
	public static final int LSA_GET_SYS_ACCESS_ACCOUNT = 0x17;
	public static final int LSA_SET_SYS_ACCESS_ACCOUNT = 0x18;
	public static final int LSA_OPEN_TRUSTED_DOM = 0x19;
	public static final int LSA_QUERY_INFO_TRUSTED_DOM = 0x1A;
	public static final int LSA_SET_INFO_TRUSTED_DOM = 0x1B;
	public static final int LSA_OPEN_SECRET = 0x1C;
	public static final int LSA_SET_SECRET = 0x1D;
	public static final int LSA_QUERY_SECRET = 0x1E;
	public static final int LSA_LOOKUP_PRIV_VAL = 0x1F;
	public static final int LSA_LOOKUP_PRIV_NAME = 0x20;
	public static final int LSA_LOOKUP_PRIV_DISP_NAME = 0x21;
	public static final int LSA_DEL_OBJ = 0x22;
	public static final int LSA_ENUM_ACCTS_WITH_USER_RIGHT = 0x23;
	public static final int LSA_ENUM_ACCT_RIGHTS = 0x24;
	public static final int LSA_ADD_ACCT_RIGHTS = 0x25;
	public static final int LSA_REM_ACCT_RIGHTS = 0x26;
	public static final int LSA_QUERY_TRUSTED_DOM_INFO = 0x27;
	public static final int LSA_SET_TRUSTED_DOM_INFO = 0x28;
	public static final int LSA_DEL_TRUSTED_DOM = 0x29;
	public static final int LSA_STORE_PRIV_DATA = 0x2A;
	public static final int LSA_RETR_PRIV_DATA = 0x2B;
	public static final int LSA_OPEN_POLICY2 = 0x2C;
	public static final int LSA_GET_USER_NAME = 0x2D;
	public static final int LSA_QUERY_INFO_POLICY2 = 0x2E;
	public static final int LSA_SET_INFO_POLICY2 = 0x2F;
	public static final int LSA_QUERY_TRUSTED_DOM_INFO_BY_NAME = 0x30;
	public static final int LSA_SET_TRUSTED_DOM_INFO_BY_NAME = 0x31;
	public static final int LSA_ENUM_TRUSTED_DOMS_EX = 0x32;
	public static final int LSA_CREATE_TRUSTED_DOM_EX = 0x33;
	public static final int LSA_CLOSE_TRUSTED_DOM_EX = 0x34;
	public static final int LSA_QUERY_DOM_INFO_POLICY = 0x35;
	public static final int LSA_SET_DOM_INFO_POLICY = 0x36;
	public static final int LSA_OPEN_TRUSTED_DOM_BY_NAME = 0x37;
	public static final int LSA_TEST_CALL = 0x38;
	public static final int LSA_LOOKUP_SIDS2 = 0x39;
	public static final int LSA_LOOKUP_NAMES2 = 0x3A;
	public static final int LSA_CREATE_TRUSTED_DOM_EX2 = 0x3B;
	public static final int LSA_CRED_WRITE = 0x3C;
	public static final int LSA_CRED_READ = 0x3D;
	public static final int LSA_CRED_ENUM = 0x3E;
	public static final int LSA_CRED_WRITE_DOM_CREDS = 0x3F;
	public static final int LSA_CRED_READ_DOM_CREDS = 0x40;
	public static final int LSA_CRED_DEL = 0x41;
	public static final int LSA_CRED_GET_TARGET_INFO = 0x42;
	public static final int LSA_CRED_PROF_LOADED = 0x43;
	public static final int LSA_LOOKUP_NAMES3 = 0x44;
	public static final int LSA_CRED_GET_SSN_TYPES = 0x45;
	public static final int LSA_REG_AUDIT_EVENT = 0x46;
	public static final int LSA_GEN_AUDIT_EVENT = 0x47;
	public static final int LSA_UNREG_AUDIT_EVENT = 0x48;
	public static final int LSA_QUERY_FOREST_TRUST_INFO = 0x49;
	public static final int LSA_SET_FOREST_TRUST_INFO = 0x4A;
	public static final int LSA_CRED_RENAME = 0x4B;

	/**
	 * Policy query levels
	 */
	public static final int POLICY_INFO_AUDIT_LOG = 1;
	public static final int POLICY_INFO_AUDIT_EVENTS = 2;
    public static final int POLICY_INFO_PRIMARY_DOMAIN = 3;
    public static final int POLICY_INFO_ACCOUNT_DOMAIN = 5;
    public static final int POLICY_INFO_SERVER_ROLE = 6;
    public static final int POLICY_INFO_REPLICA_SOURCE = 7;
    public static final int POLICY_INFO_DEFAULT_QUOTA = 8;
    public static final int POLICY_INFO_MODIFICATION = 9;
    public static final int POLICY_INFO_AUDIT_FULL_SET = 10;
    public static final int POLICY_INFO_AUDIT_FULL_QUERY = 11;
    public static final int POLICY_INFO_DNS_DOMAIN = 12;

    /**
     * utility method to encode UNICODE string prefixes
     * @param name
     * @param _dst
     */
    private static void encodeUCStringPrefix(rpc.unicode_string name,
                                             NdrBuffer _dst) {
        _dst.align(4);
        _dst.enc_ndr_short(name.length);
        _dst.enc_ndr_short(name.maximum_length);
        _dst.enc_ndr_referent(name.buffer, 1);
    }
    
    /**
     * utility method to encode UNICODE strings
     * @param name
     * @param _ndr
     * @param _dst
     */
    private static void encodeUnicodeString(rpc.unicode_string name,
                                            NetworkDataRepresentation _ndr,
                                            NdrBuffer _dst) {
        int _name_bufferl = name.length / 2;
        int _name_buffers = name.maximum_length / 2;
        _dst.enc_ndr_long(_name_buffers);
        _dst.enc_ndr_long(0);
        _dst.enc_ndr_long(_name_bufferl);
        int _name_bufferi = _dst.index;
        _dst.advance(2 * _name_bufferl);
        _dst = _dst.derive(_name_bufferi);
        for (int _i = 0; _i < _name_bufferl; _i++) {
            _dst.enc_ndr_short(name.buffer[_i]);
        }
    }
    
    /**
     * utility method to encode UNICODE string prefixes
     * @param name
     * @param _dst
     */
    private static int decodeUCStringPrefix(rpc.unicode_string name,
                                             NdrBuffer _src) {
        if (name == null) {
            name = new rpc.unicode_string();
        }
        name.length = (short) _src.dec_ndr_short();
        name.maximum_length = (short) _src.dec_ndr_short();
        return _src.dec_ndr_long();
    }
    
    /**
     * utility method to encode UNICODE strings
     * 
     * @param name
     * @param _ndr
     * @param _dst
     */
    private static void decodeUnicodeString(rpc.unicode_string name,
                                            NdrBuffer _src) throws NdrException {
        int _name_buffers = _src.dec_ndr_long();
        _src.dec_ndr_long();
        int _name_bufferl = _src.dec_ndr_long();
        int _name_bufferi = _src.index;
        _src.advance(2 * _name_bufferl);

        if (name.buffer == null) {
            if (_name_buffers < 0 || _name_buffers > 0xFFFF)
                throw new NdrException(NdrException.INVALID_CONFORMANCE);
            name.buffer = new short[_name_buffers];
        }
        _src = _src.derive(_name_bufferi);
        for (int _i = 0; _i < _name_bufferl; _i++) {
            name.buffer[_i] = (short) _src.dec_ndr_short();
        }
    }
    
    /**
     * Class for GUIDs
     * 
     * @author jwebster
     *
     */
    public static class GUID {
        public int data1;
        public short data2;
        public short data3;
        public byte data4[];

        public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
        throws NdrException {
            _dst.align(4);
            _dst.enc_ndr_long(data1);
            _dst.enc_ndr_short(data2);
            _dst.enc_ndr_short(data3);
            if (data4 != null) {
                for (int i = 0; i < 8; i++)
                    _dst.enc_ndr_small(data4[i]);
            }
            else {
                for (int i = 0; i < 8; i++)
                    _dst.enc_ndr_small(0);
            }
        }

        public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
            throws NdrException {
            _src.align(4);
            data1 = (int) _src.dec_ndr_long();
            data2 = (short) _src.dec_ndr_short();
            data3 = (short) _src.dec_ndr_short();
            if (data4 == null)
                data4 = new byte[8];
            for (int i = 0; i < 8; i++) {
                data4[i] = (byte) _src.dec_ndr_small();
            }
        }
        
        public String toString() {
            StringBuffer sb = new StringBuffer();
            sb.append(String.format("%08X", data1));
            sb.append("-");
            sb.append(String.format("%04X", data2));
            sb.append("-");
            sb.append(String.format("%04X", data3));
            sb.append("-");
            if (data4 != null) {
                for (int i = 0; i < 8; i++)
                    sb.append(String.format("%02X", data4[i]));
            }
            else
                sb.append("0000000000000000");
            return sb.toString();
        }
    }
    
	public static class LsaQosInfo extends NdrObject {

		public int length;
		public short impersonation_level;
		public byte context_mode;
		public byte effective_only;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_long(length);
			_dst.enc_ndr_short(impersonation_level);
			_dst.enc_ndr_small(context_mode);
			_dst.enc_ndr_small(effective_only);

		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			length = (int) _src.dec_ndr_long();
			impersonation_level = (short) _src.dec_ndr_short();
			context_mode = (byte) _src.dec_ndr_small();
			effective_only = (byte) _src.dec_ndr_small();

		}
	}

	/**
	 * LSA_OBJECT_ATTRIBUTES structure wrapper object.
	 * 
	 * Used with the LsarOpenPolicy request class to specify the attributes of
	 * the connection to the Policy object.
	 * 
	 * Members:
	 * 
	 * length - Specifies the size, in bytes, of the LSA_OBJECT_ATTRIBUTES
	 * structure.
	 * 
	 * root_directory - Should be NULL.
	 * 
	 * object_name - Should be NULL.
	 * 
	 * attributes - Should be zero.
	 * 
	 * security_descriptor - Should be NULL.
	 * 
	 * security_quality_of_service - Should be NULL.
	 * 
	 * @author jwebster
	 * 
	 */
	public static class LsaObjectAttributes extends NdrObject {

		public int length;
		public NdrSmall root_directory;
		public rpc.unicode_string object_name;
		public int attributes;
		public int security_descriptor;
		public LsaQosInfo security_quality_of_service;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_long(length);
			_dst.enc_ndr_referent(root_directory, 1);
			_dst.enc_ndr_referent(object_name, 1);
			_dst.enc_ndr_long(attributes);
			_dst.enc_ndr_long(security_descriptor);
			_dst.enc_ndr_referent(security_quality_of_service, 1);

			if (root_directory != null) {
				_dst = _dst.deferred;
				root_directory.encode(_ndr, _dst);

			}
			if (object_name != null) {
				_dst = _dst.deferred;
				object_name.encode(_ndr, _dst);

			}
			if (security_quality_of_service != null) {
				_dst = _dst.deferred;
				security_quality_of_service.encode(_ndr, _dst);

			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			length = (int) _src.dec_ndr_long();
			int _root_directoryp = _src.dec_ndr_long();
			int _object_namep = _src.dec_ndr_long();
			attributes = (int) _src.dec_ndr_long();
			security_descriptor = (int) _src.dec_ndr_long();
			int _security_quality_of_servicep = _src.dec_ndr_long();

			if (_root_directoryp != 0) {
				_src = _src.deferred;
				root_directory.decode(_ndr, _src);

			}
			if (_object_namep != 0) {
				if (object_name == null) {
					object_name = new rpc.unicode_string();
				}
				_src = _src.deferred;
				object_name.decode(_ndr, _src);

			}
			if (_security_quality_of_servicep != 0) {
				if (security_quality_of_service == null) {
					security_quality_of_service = new LsaQosInfo();
				}
				_src = _src.deferred;
				security_quality_of_service.decode(_ndr, _src);
			}
		}
	}

	/**
	 * POLICY_ACCOUNT_DOMAIN_INFO wrapper class.
	 * 
	 * Used to set and query the name and SID of the system's account domain.
	 * The LsaQueryInformationPolicy and LsaSetInformationPolicy functions use
	 * this structure when their InformationClass parameters are set to
	 * PolicyAccountDomainInformation.
	 * 
	 * Members:
	 * 
	 * name -name of the account domain.
	 * 
	 * sid - SID of the account domain.
	 * 
	 * @author jwebster
	 * 
	 */
	public static class LsaDomainInfo extends NdrObject {

		public rpc.unicode_string name;
		public rpc.sid_t sid;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
		    encodeUCStringPrefix(name,_dst);
			_dst.enc_ndr_referent(sid, 1);

			if (name.buffer != null) {
				_dst = _dst.deferred;
				encodeUnicodeString(name, _ndr, _dst);
			}
			if (sid != null) {
				_dst = _dst.deferred;
				sid.encode(_ndr, _dst);

			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			_src.align(4);
			int _name_bufferp = decodeUCStringPrefix(name, _src);
			int _sidp = _src.dec_ndr_long();

			if (_name_bufferp != 0) {
				_src = _src.deferred;
				decodeUnicodeString(name, _src);
			}
			if (_sidp != 0) {
				if (sid == null) {
					sid = new rpc.sid_t();
				}
				_src = _src.deferred;
				sid.decode(_ndr, _src);

			}
		}
	}

    /**
     * POLICY_DNS_DOMAIN_INFO wrapper class.
     * 
     * Used to set and query the name and SID of the system's account domain.
     * The LsaQueryInformationPolicy and LsaSetInformationPolicy functions use
     * this structure when their InformationClass parameters are set to
     * PolicyDNSDomainInformation.
     * 
     * Members:
     * 
     * name - name of the DNS domain.
     * 
     * dnsDomainName
     * 
     * dnsDomainName
     * 
     * domainGuid
     * 
     * sid - SID of the account domain.
     * 
     * @author jwebster
     * 
     */
    public static class LsaDnsDomainInfo extends NdrObject {

        public rpc.unicode_string name;
        public rpc.unicode_string fqdn;
        public rpc.unicode_string forest;
        public GUID guid;
        public rpc.sid_t sid;

        public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
                throws NdrException {
            encodeUCStringPrefix(name,_dst);
            encodeUCStringPrefix(fqdn,_dst);
            encodeUCStringPrefix(forest,_dst);
            if (guid != null) {
                _dst = _dst.deferred;
                guid.encode(_ndr, _dst);
            }
            _dst.enc_ndr_referent(sid, 1);

            if (name.buffer != null) {
                _dst = _dst.deferred;
                encodeUnicodeString(name, _ndr, _dst);
            }
            if (fqdn.buffer != null) {
                _dst = _dst.deferred;
                encodeUnicodeString(fqdn, _ndr, _dst);
            }
            if (forest.buffer != null) {
                _dst = _dst.deferred;
                encodeUnicodeString(forest, _ndr, _dst);
            }
            if (sid != null) {
                _dst = _dst.deferred;
                sid.encode(_ndr, _dst);
            }
        }

        public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
                throws NdrException {
            _src.align(4);
            _src.align(4);
            int _name_bufferp = decodeUCStringPrefix(name, _src);
            int _ddname_bufferp = decodeUCStringPrefix(fqdn, _src);
            int _dfname_bufferp = decodeUCStringPrefix(forest, _src);
            guid = new GUID();
            guid.decode(_ndr, _src);
            int _sidp = _src.dec_ndr_long();

            if (_name_bufferp != 0) {
                _src = _src.deferred;
                decodeUnicodeString(name, _src);
            }
            if (_ddname_bufferp != 0) {
                _src = _src.deferred;
                decodeUnicodeString(fqdn, _src);
            }
            if (_dfname_bufferp != 0) {
                _src = _src.deferred;
                decodeUnicodeString(forest, _src);
            }
            if (_sidp != 0) {
                if (sid == null) {
                    sid = new rpc.sid_t();
                }
                _src = _src.deferred;
                sid.decode(_ndr, _src);

            }
        }
    }

    /**
     * codec for SID pointer
     */
	public static class lsa_SidPtr extends NdrObject {

		public rpc.sid_t sid;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_referent(sid, 1);

			if (sid != null) {
				_dst = _dst.deferred;
				sid.encode(_ndr, _dst);

			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			int _sidp = _src.dec_ndr_long();

			if (_sidp != 0) {
				if (sid == null) {
					sid = new rpc.sid_t();
				}
				_src = _src.deferred;
				sid.decode(_ndr, _src);

			}
		}
	}

	/**
	 * codec for SID pointer arrays
	 */
	public static class lsa_SidArray extends NdrObject {

		public int num_sids;
		public lsa_SidPtr[] sids;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_long(num_sids);
			_dst.enc_ndr_referent(sids, 1);

			if (sids != null) {
				_dst = _dst.deferred;
				int _sidss = num_sids;
				_dst.enc_ndr_long(_sidss);
				int _sidsi = _dst.index;
				_dst.advance(4 * _sidss);

				_dst = _dst.derive(_sidsi);
				for (int _i = 0; _i < _sidss; _i++) {
					sids[_i].encode(_ndr, _dst);
				}
			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			num_sids = (int) _src.dec_ndr_long();
			int _sidsp = _src.dec_ndr_long();

			if (_sidsp != 0) {
				_src = _src.deferred;
				int _sidss = _src.dec_ndr_long();
				int _sidsi = _src.index;
				_src.advance(4 * _sidss);

				if (sids == null) {
					if (_sidss < 0 || _sidss > 0xFFFF)
						throw new NdrException(NdrException.INVALID_CONFORMANCE);
					sids = new lsa_SidPtr[_sidss];
				}
				_src = _src.derive(_sidsi);
				for (int _i = 0; _i < _sidss; _i++) {
					if (sids[_i] == null) {
						sids[_i] = new lsa_SidPtr();
					}
					sids[_i].decode(_ndr, _src);
				}
			}
		}
	}

	/**
	 * LSA_TRUST_INFORMATION wrapper class.
	 * 
	 * Identifies a domain.
	 * 
	 * Members:
	 * 
	 * name - LSA_UNICODE_STRING that contains the name of the domain.
	 * 
	 * sid - SID of the domain.
	 * 
	 * @author jwebster
	 * 
	 */
	public static class lsa_TrustInformation extends NdrObject {

		public rpc.unicode_string name;
		public rpc.sid_t sid;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_short(name.length);
			_dst.enc_ndr_short(name.maximum_length);
			_dst.enc_ndr_referent(name.buffer, 1);
			_dst.enc_ndr_referent(sid, 1);

			if (name.buffer != null) {
				_dst = _dst.deferred;
				int _name_bufferl = name.length / 2;
				int _name_buffers = name.maximum_length / 2;
				_dst.enc_ndr_long(_name_buffers);
				_dst.enc_ndr_long(0);
				_dst.enc_ndr_long(_name_bufferl);
				int _name_bufferi = _dst.index;
				_dst.advance(2 * _name_bufferl);

				_dst = _dst.derive(_name_bufferi);
				for (int _i = 0; _i < _name_bufferl; _i++) {
					_dst.enc_ndr_short(name.buffer[_i]);
				}
			}
			if (sid != null) {
				_dst = _dst.deferred;
				sid.encode(_ndr, _dst);

			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			_src.align(4);
			if (name == null) {
				name = new rpc.unicode_string();
			}
			name.length = (short) _src.dec_ndr_short();
			name.maximum_length = (short) _src.dec_ndr_short();
			int _name_bufferp = _src.dec_ndr_long();
			int _sidp = _src.dec_ndr_long();

			if (_name_bufferp != 0) {
				_src = _src.deferred;
				int _name_buffers = _src.dec_ndr_long();
				_src.dec_ndr_long();
				int _name_bufferl = _src.dec_ndr_long();
				int _name_bufferi = _src.index;
				_src.advance(2 * _name_bufferl);

				if (name.buffer == null) {
					if (_name_buffers < 0 || _name_buffers > 0xFFFF)
						throw new NdrException(NdrException.INVALID_CONFORMANCE);
					name.buffer = new short[_name_buffers];
				}
				_src = _src.derive(_name_bufferi);
				for (int _i = 0; _i < _name_bufferl; _i++) {
					name.buffer[_i] = (short) _src.dec_ndr_short();
				}
			}
			if (_sidp != 0) {
				if (sid == null) { /* YOYOYO */
					sid = new rpc.sid_t();
				}
				_src = _src.deferred;
				sid.decode(_ndr, _src);

			}
		}
	}

	/**
	 * LSA_REFERENCED_DOMAIN_LIST wrapper class.
	 * 
	 * Contains information about the domains referenced in a lookup operation.
	 * 
	 * Members:
	 * 
	 * count - Specifies the number of entries in the domains array.
	 * 
	 * domains - Array of lsa_TrustInformation objects that identify the
	 * referenced domains.
	 * 
	 * 
	 * @author jwebster
	 * 
	 */
	public static class lsa_RefDomainList extends NdrObject {

		public int count;
		public lsa_TrustInformation[] domains;
		public int max_count;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_long(count);
			_dst.enc_ndr_referent(domains, 1);
			_dst.enc_ndr_long(max_count);

			if (domains != null) {
				_dst = _dst.deferred;
				int _domainss = count;
				_dst.enc_ndr_long(_domainss);
				int _domainsi = _dst.index;
				_dst.advance(12 * _domainss);

				_dst = _dst.derive(_domainsi);
				for (int _i = 0; _i < _domainss; _i++) {
					domains[_i].encode(_ndr, _dst);
				}
			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			count = (int) _src.dec_ndr_long();
			int _domainsp = _src.dec_ndr_long();
			max_count = (int) _src.dec_ndr_long();

			if (_domainsp != 0) {
				_src = _src.deferred;
				int _domainss = _src.dec_ndr_long();
				int _domainsi = _src.index;
				_src.advance(12 * _domainss);

				if (domains == null) {
					if (_domainss < 0 || _domainss > 0xFFFF)
						throw new NdrException(NdrException.INVALID_CONFORMANCE);
					domains = new lsa_TrustInformation[_domainss];
				}
				_src = _src.derive(_domainsi);
				for (int _i = 0; _i < _domainss; _i++) {
					if (domains[_i] == null) {
						domains[_i] = new lsa_TrustInformation();
					}
					domains[_i].decode(_ndr, _src);
				}
			}
		}
	}

	/**
	 * LSA_TRANSLATED_NAME wrapper class.
	 * 
	 * Used with the LsaLookupSids function to return information about the
	 * account identified by a SID.
	 * 
	 * Members
	 * 
	 * sid_type - A value from the SID_NAME_USE enumeration that identifies the
	 * type of SID. If Use has one of the following values, one or both of the
	 * Name or DomainIndex members of LSA_TRANSLATED_NAME is not valid. These
	 * members are valid if Use has any other value.
	 * 
	 * Value Meaning:
	 * 
	 * SidTypeDomain - The DomainIndex member is valid, but the Name member is
	 * not valid and must be ignored.
	 * 
	 * SidTypeInvalid - Both DomainIndex and Name are not valid and must be
	 * ignored.
	 * 
	 * SidTypeUnknown - Both DomainIndex and Name are not valid and must be
	 * ignored.
	 * 
	 * SidTypeWellKnownGroup - The Name member is valid, but the DomainIndex
	 * member is not valid and must be ignored.
	 * 
	 * name - LSA_UNICODE_STRING that contains the isolated name of the
	 * translated SID. An isolated name is a user, group, or local group account
	 * name without the domain name (for example, user_name, rather than
	 * Acctg\\user_name).
	 * 
	 * sid_index - Specifies the zero-based index of an entry in the
	 * LSA_REFERENCED_DOMAIN_LIST structure returned by the LsaLookupSids
	 * function. The entry contains the name and SID of the domain in which the
	 * account was found. If there is no corresponding domain for an account,
	 * this member contains a negative value.
	 * 
	 * @author jwebster
	 * 
	 */
	public static class lsa_TranslatedName extends NdrObject {

		public short sid_type;
		public rpc.unicode_string name;
		public int sid_index;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_short(sid_type);
			_dst.enc_ndr_short(name.length);
			_dst.enc_ndr_short(name.maximum_length);
			_dst.enc_ndr_referent(name.buffer, 1);
			_dst.enc_ndr_long(sid_index);

			if (name.buffer != null) {
				_dst = _dst.deferred;
				int _name_bufferl = name.length / 2;
				int _name_buffers = name.maximum_length / 2;
				_dst.enc_ndr_long(_name_buffers);
				_dst.enc_ndr_long(0);
				_dst.enc_ndr_long(_name_bufferl);
				int _name_bufferi = _dst.index;
				_dst.advance(2 * _name_bufferl);

				_dst = _dst.derive(_name_bufferi);
				for (int _i = 0; _i < _name_bufferl; _i++) {
					_dst.enc_ndr_short(name.buffer[_i]);
				}
			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			sid_type = (short) _src.dec_ndr_short();
			_src.align(4);
			if (name == null) {
				name = new rpc.unicode_string();
			}
			name.length = (short) _src.dec_ndr_short();
			name.maximum_length = (short) _src.dec_ndr_short();
			int _name_bufferp = _src.dec_ndr_long();
			sid_index = (int) _src.dec_ndr_long();

			if (_name_bufferp != 0) {
				_src = _src.deferred;
				int _name_buffers = _src.dec_ndr_long();
				_src.dec_ndr_long();
				int _name_bufferl = _src.dec_ndr_long();
				int _name_bufferi = _src.index;
				_src.advance(2 * _name_bufferl);

				if (name.buffer == null) {
					if (_name_buffers < 0 || _name_buffers > 0xFFFF)
						throw new NdrException(NdrException.INVALID_CONFORMANCE);
					name.buffer = new short[_name_buffers];
				}
				_src = _src.derive(_name_bufferi);
				for (int _i = 0; _i < _name_bufferl; _i++) {
					name.buffer[_i] = (short) _src.dec_ndr_short();
				}
			}
		}
	}

	/**
	 * codec for TranslatedName array
	 */
	public static class lsa_TransNameArray extends NdrObject {

		public int count;
		public lsa_TranslatedName[] names;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_long(count);
			_dst.enc_ndr_referent(names, 1);

			if (names != null) {
				_dst = _dst.deferred;
				int _namess = count;
				_dst.enc_ndr_long(_namess);
				int _namesi = _dst.index;
				_dst.advance(16 * _namess);

				_dst = _dst.derive(_namesi);
				for (int _i = 0; _i < _namess; _i++) {
					names[_i].encode(_ndr, _dst);
				}
			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			count = (int) _src.dec_ndr_long();
			int _namesp = _src.dec_ndr_long();

			if (_namesp != 0) {
				_src = _src.deferred;
				int _namess = _src.dec_ndr_long();
				int _namesi = _src.index;
				_src.advance(16 * _namess);

				if (names == null) {
					if (_namess < 0 || _namess > 0xFFFF)
						throw new NdrException(NdrException.INVALID_CONFORMANCE);
					names = new lsa_TranslatedName[_namess];
				}
				_src = _src.derive(_namesi);
				for (int _i = 0; _i < _namess; _i++) {
					if (names[_i] == null) {
						names[_i] = new lsa_TranslatedName();
					}
					names[_i].decode(_ndr, _src);
				}
			}
		}
	}

	/**
	 * Close a handle to a Policy or TrustedDomain object class
	 * 
	 * Properties:
	 * 
	 * handle - handle to a Policy object returned by the LsaOpenPolicy function
	 * or to a TrustedDomain object returned by the LsaOpenTrustedDomainByName
	 * function.
	 * 
	 * @author jwebster
	 * 
	 */
	public static class LsarClose extends NdrObject {

		public int getOpnum() {
			return LSA_CLOSE;
		}

		public int retval;
		public rpc.policy_handle handle;

		public LsarClose(rpc.policy_handle handle) {
			this.handle = handle;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			handle.encode(_ndr, _dst);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			handle.decode(_ndr, _src);
			retval = (int) _src.dec_ndr_long();
		}
	}

	/**
	 * Retrieve information about a Policy object class.
	 * 
	 * Properties:
	 * 
	 * handle - A handle to a Policy object. The required access rights for this
	 * handle depend on the value of the InformationClass parameter. For more
	 * information, see Opening a Policy Object Handle.
	 * 
	 * level - Specifies one of the following values from the
	 * POLICY_INFORMATION_CLASS enumeration type. The value indicates the type
	 * of information to retrieve.
	 * 
	 * Value Meaning:
	 * 
	 * PolicyAuditEventsInformation - Retrieves the system's auditing rules. The
	 * handle passed in the PolicyHandle parameter must have the
	 * POLICY_VIEW_AUDIT_INFORMATION access right. The Buffer parameter receives
	 * a pointer to a POLICY_AUDIT_EVENTS_INFO structure.
	 * 
	 * PolicyPrimaryDomainInformation - Retrieves the name and SID of the
	 * system's primary domain. The handle passed in the PolicyHandle parameter
	 * must have the POLICY_VIEW_LOCAL_INFORMATION access right. The Buffer
	 * parameter receives a pointer to a POLICY_PRIMARY_DOMAIN_INFO structure.
	 * 
	 * PolicyAccountDomainInformation - Retrieves the name and SID of the
	 * system's account domain. The handle passed in the PolicyHandle parameter
	 * must have the POLICY_VIEW_LOCAL_INFORMATION access right. The Buffer
	 * parameter receives a pointer to a POLICY_ACCOUNT_DOMAIN_INFO structure.
	 * 
	 * PolicyLsaServerRoleInformation - Retrieves the role of an LSA server. The
	 * handle passed in the PolicyHandle parameter must have the
	 * POLICY_VIEW_LOCAL_INFORMATION access right. The Buffer parameter receives
	 * a pointer to a POLICY_LSA_SERVER_ROLE_INFO structure.
	 * 
	 * PolicyModificationInformation - Retrieves information about the creation
	 * time and last modification of the LSA database. The handle passed in the
	 * PolicyHandle parameter must have the POLICY_VIEW_LOCAL_INFORMATION access
	 * right. The Buffer parameter receives a pointer to a
	 * POLICY_MODIFICATION_INFO structure.
	 * 
	 * PolicyDnsDomainInformation - Retrieves the Domain Name System (DNS)
	 * information about the primary domain associated with the Policy object.
	 * The handle passed in the PolicyHandle parameter must have the
	 * POLICY_VIEW_LOCAL_INFORMATION access right. The Buffer parameter receives
	 * a pointer to a POLICY_DNS_DOMAIN_INFO structure.
	 * 
	 * info - structure containing the requested information. The type of
	 * structure depends on the value of the InformationClass parameter.
	 * 
	 * @author jwebster
	 * 
	 */
	public static class LsarQueryInformationPolicy extends NdrObject {

		public int getOpnum() {
			return LSA_QUERY_INFO_POLICY2;
		}

		public int retval;
		public rpc.policy_handle handle;
		public short level;
		public NdrObject info;

		public LsarQueryInformationPolicy(rpc.policy_handle handle,
				short level, NdrObject info) {
			this.handle = handle;
			this.level = level;
			this.info = info;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			handle.encode(_ndr, _dst);
			_dst.enc_ndr_short(level);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			int _infop = _src.dec_ndr_long();
			if (_infop != 0) {
				_src.dec_ndr_short(); /* union discriminant */
				info.decode(_ndr, _src);

			}
			retval = (int) _src.dec_ndr_long();
		}
	}

	/**
	 * Look up names that correspond to security identifiers (SIDs) class
	 * 
	 * Properties:
	 * 
	 * handle - A handle to a Policy object. This handle must have the
	 * POLICY_LOOKUP_NAMES access right. For more information, see Opening a
	 * Policy Object Handle.
	 * 
	 * count - Specifies the number of SIDs in the Sids array. This is also the
	 * number of entries returned in the Names array.
	 * 
	 * sids - Array of SID pointers to look up. The SIDs can be well-known SIDs,
	 * user, group, or local group account SIDs, or domain SIDs.
	 * 
	 * domains - LSA_REFERENCED_DOMAIN_LIST structure. The Domains member of
	 * this structure is an array that contains an entry for each domain in
	 * which a SID was found. The entry for each domain contains the SID and
	 * flat name of the domain. For Windows domains, the flat name is the
	 * NetBIOS name. For links with non–Windows domains, the flat name is the
	 * identifying name of that domain, or it is NULL.
	 * 
	 * names - Array of LSA_TRANSLATED_NAME structures. Each entry in the Names
	 * array contains the name information for the corresponding entry in the
	 * Sids array. For account SIDs, the Name member of each structure contains
	 * the isolated name of the account. For domain SIDs, the name member is not
	 * valid. The DomainIndex member of each entry in the names array is the
	 * index of an entry in the Domains array returned in the domains parameter.
	 * The index identifies the domains array for the domain in which the SID
	 * was found.
	 * 
	 * @author jwebster
	 * 
	 */
	public static class LsarLookupSids extends NdrObject {

		public int getOpnum() {
			return LSA_LOOKUP_SIDS;
		}

		public int retval;
		public rpc.policy_handle handle;
		public lsa_SidArray sids;
		public lsa_RefDomainList domains;
		public lsa_TransNameArray names;
		public short level;
		public int count;

		public LsarLookupSids(rpc.policy_handle handle, lsa_SidArray sids,
				lsa_RefDomainList domains, lsa_TransNameArray names,
				short level, int count) {
			this.handle = handle;
			this.sids = sids;
			this.domains = domains;
			this.names = names;
			this.level = level;
			this.count = count;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			handle.encode(_ndr, _dst);
			sids.encode(_ndr, _dst);
			names.encode(_ndr, _dst);
			_dst.enc_ndr_short(level);
			_dst.enc_ndr_long(count);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			int _domainsp = _src.dec_ndr_long();
			if (_domainsp != 0) {
				if (domains == null) { /* YOYOYO */
					domains = new lsa_RefDomainList();
				}
				domains.decode(_ndr, _src);

			}
			names.decode(_ndr, _src);
			count = (int) _src.dec_ndr_long();
			retval = (int) _src.dec_ndr_long();
		}
	}

	/**
	 * Open a handle to the Policy object on local or remote system class
	 * 
	 * Properties:
	 * 
	 * system_name - LSA_UNICODE_STRING structure that contains the name of the
	 * target system. The name can have the form "computer_name" or
	 * "\\computer_name". If this parameter is NULL, the function opens the
	 * Policy object on the local system.
	 * 
	 * object_attributes - LSA_OBJECT_ATTRIBUTES structure that specifies the
	 * connection attributes. The structure members are not used; initialize
	 * them to NULL or zero.
	 * 
	 * desired_access - An ACCESS_MASK that specifies the requested access
	 * rights. The function fails if the DACL of the target system does not
	 * allow the caller the requested access. To determine the access rights
	 * that you need, see the documentation for the LSA functions with which you
	 * want to use the policy handle.
	 * 
	 * policy_handle - LSA_HANDLE variable that receives a handle to the Policy
	 * object.
	 * 
	 * @author jwebster
	 * 
	 */
	public static class LsarOpenPolicy extends NdrObject {

		public int getOpnum() {
			return LSA_OPEN_POLICY2;
		}

		public int retval;
		public String system_name;
		public LsaObjectAttributes object_attributes;
		public int desired_access;
		public rpc.policy_handle policy_handle;

		public LsarOpenPolicy(String system_name,
				LsaObjectAttributes object_attributes, int desired_access,
				rpc.policy_handle policy_handle) {
			this.system_name = system_name;
			this.object_attributes = object_attributes;
			this.desired_access = desired_access;
			this.policy_handle = policy_handle;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.enc_ndr_referent(system_name, 1);
			if (system_name != null) {
				_dst.enc_ndr_string(system_name);

			}
			object_attributes.encode(_ndr, _dst);
			_dst.enc_ndr_long(desired_access);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			policy_handle.decode(_ndr, _src);
			retval = (int) _src.dec_ndr_long();
		}
	}
}
