/**
 * Jarapac DCE/RPC Framework
 * 
 * Copyright (C) 2007 StillSecure www.stillsecure.com
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * Class: srvsvc.java
 * 
 * Author: Joe Webster
 * 
 * Description: provides srvsvc (Lanman Server Service) services
 * 
 */
package msrpc;

import rpc.*;
import ndr.*;

/**
 * This class was originally generated via the midlc compiler from IDL code
 * provided with Jarapac and Samba 4.0.0tp4. It has been significantly altered
 * for for this implementation.
 * 
 * @author Joe Webster
 * 
 */
public class srvsvc extends Stub {

	/**
	 * srvsvc pipe
	 */
	public static final int SRV_NETCONNENUM = 0x08;
	public static final int SRV_NETFILEENUM = 0x09;
	public static final int SRV_NET_FILE_CLOSE = 0x0B;
	public static final int SRV_NETSESSENUM = 0x0C;
	public static final int SRV_NET_SESS_CLOSE = 0x0D;
	public static final int SRV_NET_SHARE_ADD = 0x0E;
	public static final int SRV_NETSHAREENUM = 0x0F;
	public static final int SRV_NETSHAREGETINFO = 0x10;
	public static final int SRV_NETSHARESETINFO = 0x11;
	public static final int SRV_NETSHAREDEL = 0x12;
	public static final int SRV_NETTRANSPORTENUM = 0x1A;
	public static final int SRV_NET_SRV_GET_INFO = 0x15;
	public static final int SRV_NET_SRV_SET_INFO = 0x16;
	public static final int SRV_NET_DISK_ENUM = 0x17;
	public static final int SRV_NET_REMOTE_TOD = 0x1C;
	public static final int SRV_NETSHAREENUM2 = 0x24;

	/**
	 * net share types
	 */
	public static final int STYPE_DISKTREE = 0x00;
	public static final int STYPE_IPC_HIDDEN = 0x80000003;
	public static final int STYPE_DISKTREE_HIDDEN = 0x80000000;

	/**
	 * server info types
	 */
	public static final int SV_TYPE_WORKSTATION = 0x01;
	public static final int SV_TYPE_SERVER = 0x02;
	public static final int SV_TYPE_SQLSERVER = 0x04;
	public static final int SV_TYPE_DOMAIN_CTRL = 0x08;
	public static final int SV_TYPE_DOMAIN_BAKCTRL = 0x10;
	public static final int SV_TYPE_TIME_SOURCE = 0x20;
	public static final int SV_TYPE_AFP = 0x40;
	public static final int SV_TYPE_NOVELL = 0x80;
	public static final int SV_TYPE_DOMAIN_MEMBER = 0x100;
	public static final int SV_TYPE_PRINTQ_SERVER = 0x200;
	public static final int SV_TYPE_DIALIN_SERVER = 0x400;
	public static final int SV_TYPE_XENIX_SERVER = 0x800;
	public static final int SV_TYPE_SERVER_UNIX = SV_TYPE_XENIX_SERVER;
	public static final int SV_TYPE_NT = 0x1000;
	public static final int SV_TYPE_WFW = 0x2000;
	public static final int SV_TYPE_SERVER_MFPN = 0x4000;
	public static final int SV_TYPE_SERVER_NT = 0x8000;
	public static final int SV_TYPE_POTENTIAL_BROWSER = 0x10000;
	public static final int SV_TYPE_BACKUP_BROWSER = 0x20000;
	public static final int SV_TYPE_MASTER_BROWSER = 0x40000;
	public static final int SV_TYPE_DOMAIN_MASTER = 0x80000;
	public static final int SV_TYPE_SERVER_OSF = 0x100000;
	public static final int SV_TYPE_SERVER_VMS = 0x200000;

	// Windows95 and above
	public static final int SV_TYPE_WINDOWS = 0x400000;

	// Root of a DFS tree
	public static final int SV_TYPE_DFS = 0x800000;

	// NT Cluster
	public static final int SV_TYPE_CLUSTER_NT = 0x1000000;

	// Terminal Server(Hydra)
	public static final int SV_TYPE_TERMINALSERVER = 0x2000000;

	// NT Cluster Virtual Server Name
	public static final int SV_TYPE_CLUSTER_VS_NT = 0x4000000;

	// IBM DSS (Directory and Security Services) or equivalent
	public static final int SV_TYPE_DCE = 0x10000000;

	// return list for alternate transport
	public static final int SV_TYPE_ALTERNATE_XPORT = 0x20000000;

	// Return local list only
	public static final int SV_TYPE_LOCAL_LIST_ONLY = 0x40000000;

	public static final int SV_TYPE_DOMAIN_ENUM = 0x80000000;

	// handy for NetServerEnum2
	public static final int SV_TYPE_ALL = 0xFFFFFFFF;

	// most significant nibble is server type
	public static final int MAJOR_VERSION_MASK = 0x0F;

	// platform id
	public static final int PLATFORM_ID_NT = 500;

	public static final String MY_SYNTAX = "4b324fc8-1670-01d3-1278-5a47bf6ee188:3.0";

	public String getSyntax() {
		return MY_SYNTAX;
	}

	public static class ShareInfo0 extends NdrObject {

		public String netname;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_referent(netname, 1);

			if (netname != null) {
				_dst = _dst.deferred;
				_dst.enc_ndr_string(netname);

			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			int _netnamep = _src.dec_ndr_long();

			if (_netnamep != 0) {
				_src = _src.deferred;
				netname = _src.dec_ndr_string();

			}
		}
	}

	public static class ShareInfoCtr0 extends NdrObject {

		public int count;
		public ShareInfo0[] array;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_long(count);
			_dst.enc_ndr_referent(array, 1);

			if (array != null) {
				_dst = _dst.deferred;
				int _arrays = count;
				_dst.enc_ndr_long(_arrays);
				int _arrayi = _dst.index;
				_dst.advance(4 * _arrays);

				_dst = _dst.derive(_arrayi);
				for (int _i = 0; _i < _arrays; _i++) {
					array[_i].encode(_ndr, _dst);
				}
			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			count = (int) _src.dec_ndr_long();
			int _arrayp = _src.dec_ndr_long();

			if (_arrayp != 0) {
				_src = _src.deferred;
				int _arrays = _src.dec_ndr_long();
				int _arrayi = _src.index;
				_src.advance(4 * _arrays);

				if (array == null) {
					if (_arrays < 0 || _arrays > 0xFFFF)
						throw new NdrException(NdrException.INVALID_CONFORMANCE);
					array = new ShareInfo0[_arrays];
				}
				_src = _src.derive(_arrayi);
				for (int _i = 0; _i < _arrays; _i++) {
					if (array[_i] == null) {
						array[_i] = new ShareInfo0();
					}
					array[_i].decode(_ndr, _src);
				}
			}
		}
	}

	public static class ShareInfo1 extends NdrObject {

		public String netname;
		public int type;
		public String remark;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_referent(netname, 1);
			_dst.enc_ndr_long(type);
			_dst.enc_ndr_referent(remark, 1);

			if (netname != null) {
				_dst = _dst.deferred;
				_dst.enc_ndr_string(netname);

			}
			if (remark != null) {
				_dst = _dst.deferred;
				_dst.enc_ndr_string(remark);

			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			int _netnamep = _src.dec_ndr_long();
			type = (int) _src.dec_ndr_long();
			int _remarkp = _src.dec_ndr_long();

			if (_netnamep != 0) {
				_src = _src.deferred;
				netname = _src.dec_ndr_string();
			}
			if (_remarkp != 0) {
				_src = _src.deferred;
				remark = _src.dec_ndr_string();
			}
		}
	}

	public static class ShareInfoCtr1 extends NdrObject {

		public int count;
		public ShareInfo1[] array;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_long(count);
			_dst.enc_ndr_referent(array, 1);

			if (array != null) {
				_dst = _dst.deferred;
				int _arrays = count;
				_dst.enc_ndr_long(_arrays);
				int _arrayi = _dst.index;
				_dst.advance(12 * _arrays);

				_dst = _dst.derive(_arrayi);
				for (int _i = 0; _i < _arrays; _i++) {
					array[_i].encode(_ndr, _dst);
				}
			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			count = (int) _src.dec_ndr_long();
			int _arrayp = _src.dec_ndr_long();

			if (_arrayp != 0) {
				_src = _src.deferred;
				int _arrays = _src.dec_ndr_long();
				int _arrayi = _src.index;
				_src.advance(12 * _arrays);

				if (array == null) {
					if (_arrays < 0 || _arrays > 0xFFFF)
						throw new NdrException(NdrException.INVALID_CONFORMANCE);
					array = new ShareInfo1[_arrays];
				}
				_src = _src.derive(_arrayi);
				for (int _i = 0; _i < _arrays; _i++) {
					if (array[_i] == null) {
						array[_i] = new ShareInfo1();
					}
					array[_i].decode(_ndr, _src);
				}
			}
		}
	}

	public static class TransportInfo1 extends NdrObject {

		public int vcs;
		public String name;
		public String addr;
		public int addrlen;
		public String netaddr;
		public String domain;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_referent(name, 1);
			_dst.enc_ndr_referent(addr, 1);
			_dst.enc_ndr_referent(netaddr, 1);
			_dst.enc_ndr_referent(domain, 1);

			if (name != null) {
				_dst = _dst.deferred;
				_dst.enc_ndr_string(name);
			}
			if (addr != null) {
				_dst = _dst.deferred;
				_dst.enc_ndr_string(addr);
			}
			if (netaddr != null) {
				_dst = _dst.deferred;
				_dst.enc_ndr_string(netaddr);
			}
			if (domain != null) {
				_dst = _dst.deferred;
				_dst.enc_ndr_string(domain);
			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			vcs = (int) _src.dec_ndr_long();
			int _namep = _src.dec_ndr_long();
			int _addrp = _src.dec_ndr_long();
			addrlen = (int) _src.dec_ndr_long();
			int _netaddrp = _src.dec_ndr_long();
			int _domainp = _src.dec_ndr_long();
			if (_namep != 0) {
				_src = _src.deferred;
				name = _src.dec_ndr_string();
			}
			if (_addrp != 0) {
				_src = _src.deferred;
				StringBuffer addrSb = new StringBuffer();
				int _addrc = _src.dec_ndr_long();
				for (int _i = 0; _i < _addrc; _i++) {
					addrSb.append((char) _src.dec_ndr_small());
				}
				addr = addrSb.toString();
			}
			if (_netaddrp != 0) {
				_src = _src.deferred;
				netaddr = _src.dec_ndr_string();
			}
			if (_domainp != 0) {
				_src = _src.deferred;
				domain = _src.dec_ndr_string();
			}
		}
	}

	public static class TransportCtr0 extends NdrObject {

		public int count;
		public TransportInfo1[] array = null;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_long(count);
			_dst.enc_ndr_referent(array, 1);

			if (array != null) {
				_dst = _dst.deferred;
				int _arrays = count;
				_dst.enc_ndr_long(_arrays);
				int _arrayi = _dst.index;
				_dst.advance(24 * _arrays);

				_dst = _dst.derive(_arrayi);
				for (int _i = 0; _i < _arrays; _i++) {
					array[_i].encode(_ndr, _dst);
				}
			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			count = (int) _src.dec_ndr_long();
			int _arrayp = _src.dec_ndr_long();

			if (_arrayp != 0) {
				_src = _src.deferred;
				int _arrays = _src.dec_ndr_long();
				int _arrayi = _src.index;
				_src.advance(24 * _arrays);

				if (array == null) {
					if (_arrays < 0 || _arrays > 0xFFFF)
						throw new NdrException(NdrException.INVALID_CONFORMANCE);
					array = new TransportInfo1[_arrays];
				}
				_src = _src.derive(_arrayi);
				for (int _i = 0; _i < _arrays; _i++) {
					if (array[_i] == null) {
						array[_i] = new TransportInfo1();
					}
					array[_i].decode(_ndr, _src);
				}
			}
		}
	}

	public static abstract class SrvCmd extends NdrObject {

		public int retval;
		public String servername;
		public int level;
		public NdrObject info;
	}

	/**
	 * 
	 * @author jwebster
	 *
	 */
	public static class ShareEnumAll extends SrvCmd {

		public int getOpnum() {
			return SRV_NETSHAREENUM;
		}

		public int prefmaxlen;
		public int totalentries;
		public int resume_handle;

		public ShareEnumAll(String servername, int level, NdrObject info,
				int prefmaxlen, int totalentries, int resume_handle) {
			this.servername = servername;
			this.level = level;
			this.info = info;
			this.prefmaxlen = prefmaxlen;
			this.totalentries = totalentries;
			this.resume_handle = resume_handle;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.enc_ndr_referent(servername, 1);
			if (servername != null) {
				_dst.enc_ndr_string(servername);
			}
			_dst.enc_ndr_long(level);
			int _descr = level;
			_dst.enc_ndr_long(_descr);
			_dst.enc_ndr_referent(info, 1);
			if (info != null) {
				_dst = _dst.deferred;
				info.encode(_ndr, _dst);
			}
			_dst.enc_ndr_long(prefmaxlen);
			_dst.enc_ndr_long(resume_handle);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			level = (int) _src.dec_ndr_long();
			_src.dec_ndr_long(); /* union discriminant */
			int _infop = _src.dec_ndr_long();
			if (_infop != 0) {
				if (info == null) {
					info = new ShareInfoCtr0();
				}
				_src = _src.deferred;
				info.decode(_ndr, _src);
			}
			totalentries = (int) _src.dec_ndr_long();
			resume_handle = (int) _src.dec_ndr_long();
			retval = (int) _src.dec_ndr_long();
		}
	}

	public static class TransportEnum extends SrvCmd {

		public int getOpnum() {
			return SRV_NETTRANSPORTENUM;
		}

		public int maxbuffer;
		public int totalentries;
		public int resume_handle;

		public TransportEnum(String servername, int level, NdrObject info,
				int maxbuffer, int totalentries, int resume_handle) {
			this.servername = servername;
			this.level = level;
			this.info = info;
			this.maxbuffer = maxbuffer;
			this.totalentries = totalentries;
			this.resume_handle = resume_handle;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.enc_ndr_referent(servername, 1);
			if (servername != null) {
				_dst.enc_ndr_string(servername);
			}
			_dst.enc_ndr_long(level);
			int _descr = level;
			_dst.enc_ndr_long(_descr);
			_dst.enc_ndr_referent(info, 1);
			if (info != null) {
				_dst = _dst.deferred;
				info.encode(_ndr, _dst);
			}
			_dst.enc_ndr_long(maxbuffer);
			_dst.enc_ndr_long(resume_handle);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			level = (int) _src.dec_ndr_long();
			_src.dec_ndr_long(); /* union discriminant */
			int _infop = _src.dec_ndr_long();
			if (_infop != 0) {
				if (info == null) {
					info = new TransportCtr0();
				}
				_src = _src.deferred;
				info.decode(_ndr, _src);
			}
			totalentries = (int) _src.dec_ndr_long();
			resume_handle = (int) _src.dec_ndr_long();
			retval = (int) _src.dec_ndr_long();
		}
	}

	/**
	 * Server Info format 100
	 * 
	 */
	public static class ServerInfo100 extends NdrObject {

		public int platform_id;
		public String name;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_long(platform_id);
			_dst.enc_ndr_referent(name, 1);

			if (name != null) {
				_dst = _dst.deferred;
				_dst.enc_ndr_string(name);
			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			platform_id = (int) _src.dec_ndr_long();
			int _namep = _src.dec_ndr_long();

			if (_namep != 0) {
				_src = _src.deferred;
				name = _src.dec_ndr_string();
			}
		}
	}

	/**
	 * Server Info format 102
	 * 
	 */
	public static class ServerInfo102 extends NdrObject {

		public int platform_id;
		public String name;
		public int version_major;
		public int version_minor;
		public int type;
		public String comment;
		public int users;
		public int disc;
		public short hidden;
		public int announce;
		public int anndelta;
		public int licenses;
		public String userpath;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_long(platform_id);
			_dst.enc_ndr_referent(name, 1);
			_dst.enc_ndr_long(version_major);
			_dst.enc_ndr_long(version_minor);
			_dst.enc_ndr_long(type);
			_dst.enc_ndr_referent(comment, 1);
			_dst.enc_ndr_long(users);
			_dst.enc_ndr_long(disc);
			_dst.enc_ndr_short(hidden);
			_dst.enc_ndr_long(announce);
			_dst.enc_ndr_long(anndelta);
			_dst.enc_ndr_long(licenses);
			_dst.enc_ndr_referent(userpath, 1);

			if (name != null) {
				_dst = _dst.deferred;
				_dst.enc_ndr_string(name);

			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			platform_id = (int) _src.dec_ndr_long();
			int _namep = _src.dec_ndr_long();
			version_major = (int) _src.dec_ndr_long() & MAJOR_VERSION_MASK;
			version_minor = (int) _src.dec_ndr_long();
			type = (int) _src.dec_ndr_long();
			int _commentp = _src.dec_ndr_long();
			users = (int) _src.dec_ndr_long();
			disc = (int) _src.dec_ndr_long();
			hidden = (short) _src.dec_ndr_long();
			announce = (int) _src.dec_ndr_long();
			anndelta = (int) _src.dec_ndr_long();
			licenses = (int) _src.dec_ndr_long();
			int _userpathp = _src.dec_ndr_long();

			if (_namep != 0) {
				_src = _src.deferred;
				name = _src.dec_ndr_string();
			} else
				name = null;
			if (_commentp != 0) {
				_src = _src.deferred;
				comment = _src.dec_ndr_string();
			} else
				comment = null;
			if (_userpathp != 0) {
				_src = _src.deferred;
				userpath = _src.dec_ndr_string();
			} else
				userpath = null;
		}
	}

	public static class ServerGetInfo extends SrvCmd {

		public int getOpnum() {
			return SRV_NET_SRV_GET_INFO;
		}

		public ServerGetInfo(String servername, int level, NdrObject info) {
			this.servername = servername;
			this.level = level;
			this.info = info;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.enc_ndr_referent(servername, 1);
			if (servername != null) {
				_dst.enc_ndr_string(servername);
			}
			_dst.enc_ndr_long(level);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.dec_ndr_long(); /* union discriminant */
			int _infop = _src.dec_ndr_long();
			if (_infop != 0) {
				if (info == null) {
					if (level == 100)
						info = new ServerInfo100();
					else
						info = new ServerInfo102();
				}
				_src = _src.deferred;
				info.decode(_ndr, _src);
			}
			retval = (int) _src.dec_ndr_long();
		}
	}

	public static class TimeOfDayInfo extends NdrObject {

		public int elapsedt;
		public int msecs;
		public int hours;
		public int mins;
		public int secs;
		public int hunds;
		public int timezone;
		public int tinterval;
		public int day;
		public int month;
		public int year;
		public int weekday;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_long(elapsedt);
			_dst.enc_ndr_long(msecs);
			_dst.enc_ndr_long(hours);
			_dst.enc_ndr_long(mins);
			_dst.enc_ndr_long(secs);
			_dst.enc_ndr_long(hunds);
			_dst.enc_ndr_long(timezone);
			_dst.enc_ndr_long(tinterval);
			_dst.enc_ndr_long(day);
			_dst.enc_ndr_long(month);
			_dst.enc_ndr_long(year);
			_dst.enc_ndr_long(weekday);

		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			elapsedt = (int) _src.dec_ndr_long();
			msecs = (int) _src.dec_ndr_long();
			hours = (int) _src.dec_ndr_long();
			mins = (int) _src.dec_ndr_long();
			secs = (int) _src.dec_ndr_long();
			hunds = (int) _src.dec_ndr_long();
			timezone = (int) _src.dec_ndr_long();
			tinterval = (int) _src.dec_ndr_long();
			day = (int) _src.dec_ndr_long();
			month = (int) _src.dec_ndr_long();
			year = (int) _src.dec_ndr_long();
			weekday = (int) _src.dec_ndr_long();

		}
	}

	public static class RemoteTOD extends SrvCmd {

		public int getOpnum() {
			return SRV_NET_REMOTE_TOD;
		}

		public TimeOfDayInfo info;

		public RemoteTOD(String servername, TimeOfDayInfo info) {
			this.servername = servername;
			this.info = info;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.enc_ndr_referent(servername, 1);
			if (servername != null) {
				_dst.enc_ndr_string(servername);

			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			int _infop = _src.dec_ndr_long();
			if (_infop != 0) {
				if (info == null) {
					info = new TimeOfDayInfo();
				}
				info.decode(_ndr, _src);

			}
			retval = (int) _src.dec_ndr_long();
		}
	}
}
