/**
 * Jarapac DCE/RPC Framework
 * 
 * Copyright (C) 2008 StillSecure www.stillsecure.com
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * Class: svcctl.java
 * 
 * Author: Joe Webster
 * 
 * Description: provides svcctl (Services Control) services.
 * 
 */
package msrpc;

import rpc.*;
import ndr.*;

/**
 * This class was originally generated via the midlc compiler from IDL code
 * provided with Jarapac and Samba 4.0.0tp4. It has been significantly altered
 * for for this implementation.
 * 
 * @author Joe Webster
 * 
 */
public class svcctl extends Stub {

	/**
	 * svcctl pipe
	 */
	public static final int SVC_CLOSE = 0x00;
	public static final int SVC_CONTROL_SERVICE = 0x01;
	public static final int SVC_DELETE = 0x02; /* possibly */
	public static final int SVC_LOCK = 0x03;
	public static final int SVC_GET_SVC_SEC = 0x04;
	public static final int SVC_QUERY_SVC_STATUS = 0x06;
	public static final int SVC_UNLOCK = 0x08;
	public static final int SVC_CHANGE_SVC_CONFIG = 0x0B;
	public static final int SVC_CREATE_SERVICE = 0x0C;
	public static final int SVC_ENUM_SVCS_STATUS = 0x0E;
	public static final int SVC_OPEN_SC_MAN = 0x0F;
	public static final int SVC_OPEN_SERVICE = 0x10;
	public static final int SVC_QUERY_SVC_CONFIG = 0x11;
	public static final int SVC_QUERY_LOCK = 0x12;
	public static final int SVC_START_SERVICE = 0x13;
	public static final int SVC_QUERY_DISP_NAME = 0x14;
	public static final int SVC_OPEN_SC_MAN_A = 0x1B;
	public static final int SVC_OPEN_SERVICE_A = 0x1C;

	// SVC_Q_START_SERVICE
	public static final int MAX_SVC_ARGS = 10;

	// SVC_Q_ENUM_SVCS_STATUS
	public static final int MAX_SERVICES = 50;

	/**
	 * Service control constants
	 */
	public static final int SERVICE_CONTROL_STOP = 1;
	public static final int SERVICE_CONTROL_PAUSE = 2;
	public static final int SERVICE_CONTROL_CONTINUE = 3;
	public static final int SERVICE_CONTROL_INTERROGATE = 4;

	/**
	 * Constants for the state of a service
	 */
	public static final int SERVICE_STOPPED = 1;
	public static final int SERVICE_START_PENDING = 2;
	public static final int SERVICE_STOP_PENDING = 3;
	public static final int SERVICE_RUNNING = 4;
	public static final int SERVICE_CONTINUE_PENDING = 5;
	public static final int SERVICE_PAUSE_PENDING = 6;
	public static final int SERVICE_PAUSED = 7;

	/**
	 * Service specific security
	 */
	public static final int SEC_SERVICE_ALL_ACCESS = 0xF01FF;
	public static final int SEC_SERVICE_QUERY_CONFIG = 0x0001;
	public static final int SEC_SERVICE_CHANGE_CONFIG = 0x0002;
	public static final int SEC_SERVICE_QUERY_STATUS = 0x0004;
	public static final int SEC_SERVICE_ENUMERATE_DEPENDENTS = 0x0008;
	public static final int SEC_SERVICE_START = 0x0010;
	public static final int SEC_SERVICE_STOP = 0x0020;
	public static final int SEC_SERVICE_PAUSE_CONTINUE = 0x0040;
	public static final int SEC_SERVICE_INTERROGATE = 0x0080;
	public static final int SEC_SERVICE_USER_DEFINED_CONTROL = 0x0100;

	/**
	 * Service types
	 */
	// File system driver service.
	public static final int SERVICE_FILE_SYSTEM_DRIVER = 0x00000002;

	// Driver service.
	public static final int SERVICE_KERNEL_DRIVER = 0x00000001;

	// Service that runs in its own process.
	public static final int SERVICE_WIN32_OWN_PROCESS = 0x00000010;

	// Service that shares a process with other services.
	public static final int SERVICE_WIN32_SHARE_PROCESS = 0x00000020;

	// The service can interact with the desktop.
	public static final int SERVICE_INTERACTIVE_PROCESS = 0x00000100;

	/**
	 * Service start types
	 */
	// Service started automatically by the service control manager
	// during system startup.
	public static final int SERVICE_AUTO_START = 0x00000002;

	// Device driver started by the system loader.
	// This value is valid only for driver services.
	public static final int SERVICE_BOOT_START = 0x00000000;

	// Service started by the service control manager when a process calls
	// the StartService function.
	public static final int SERVICE_DEMAND_START = 0x00000003;

	// Service that cannot be started. Attempts to start the service result in
	// the error code ERROR_SERVICE_DISABLED.
	public static final int SERVICE_DISABLED = 0x00000004;

	// Device driver started by the IoInitSystem function.
	// This value is valid only for driver services.
	public static final int SERVICE_SYSTEM_START = 0x00000001;

	/**
	 * Service error control codes
	 */
	// Startup program logs the error in the event log, if possible.
	// If the last-known good configuration is being started, the
	// startup operation fails. Otherwise, the system is restarted with the
	// last-known good configuration.
	public static final int SERVICE_ERROR_CRITICAL = 0x00000003;

	// Startup program ignores the error and continues the startup operation.
	public static final int SERVICE_ERROR_IGNORE = 0x00000000;

	// Startup program logs the error in the event log and continues
	// the startup operation.
	public static final int SERVICE_ERROR_NORMAL = 0x00000001;

	// Startup program logs the error in the event log.
	// If the last-known good configuration is being started, the startup
	// operation continues. Otherwise, the system is restarted with the
	// last-known-good configuration.
	public static final int SERVICE_ERROR_SEVERE = 0x00000002;

	public static final String MY_SYNTAX = "367abb81-9844-35f1-ad32-98f038001003:2.0";

	public String getSyntax() {
		return MY_SYNTAX;
	}

	/**
	 * Service control manager access bitmaps
	 */
	public static final int SC_MANAGER_MAX_ALLOWED = 0x02000000;
	public static final int SC_MANAGER_NO_CREATE = 0x1D;
	public static final int SC_MANAGER_ALL_ACCESS = 0x3F;

	/**
	 * base class for all svcctl commands. defines properties common to all.
	 * 
	 * Properties:
	 * 
	 * handle - A handle to the service. This handle is returned by the
	 * OpenService or CreateService function, and it must have the
	 * SERVICE_QUERY_CONFIG access right.
	 * 
	 * access_mask - The access to the service control manager. For a list of
	 * access rights, see Service Security and Access Rights. Before granting
	 * the requested access rights, the system checks the access token of the
	 * calling process against the discretionary access-control list of the
	 * security descriptor associated with the service control manager.
	 * 
	 * retval - If the function succeeds, the return value is nonzero. If the
	 * function fails, the return value is zero. The following error codes can
	 * be set by the service control manager. Others can be set by the registry
	 * functions that are called by the service control manager.
	 * 
	 * ERROR_ACCESS_DENIED - The handle does not have the SERVICE_QUERY_CONFIG
	 * access right.
	 * 
	 * ERROR_INSUFFICIENT_BUFFER - There is more service configuration
	 * information than would fit into the serviceConfig buffer. The number of
	 * bytes required to get all the information is returned in the bytesNeeded
	 * parameter. Nothing is written to serviceConfig.
	 * 
	 * ERROR_INVALID_HANDLE - The specified handle is invalid.
	 */
	public static abstract class SvcCtlCmd extends NdrObject {

		public int retval;
		public rpc.policy_handle handle;
		public int access_mask;

	}

	public static class CloseServiceHandle extends SvcCtlCmd {

		public int getOpnum() {
			return SVC_CLOSE;
		}

		public CloseServiceHandle(rpc.policy_handle handle) {
			this.handle = handle;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			handle.encode(_ndr, _dst);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			handle.decode(_ndr, _src);
			retval = (int) _src.dec_ndr_long();
		}
	}

	/**
	 * Open Service Control Manager class
	 * 
	 * Properties:
	 * 
	 * machine_name - The name of the target computer. If the pointer is NULL or
	 * points to an empty string, the function connects to the service control
	 * manager on the local computer.
	 * 
	 * database_name - The name of the service control manager database. This
	 * parameter should be set to SERVICES_ACTIVE_DATABASE. If it is NULL, the
	 * SERVICES_ACTIVE_DATABASE database is opened by default.
	 * 
	 * The SC_MANAGER_CONNECT access right is implicitly specified by calling
	 * this function.
	 * 
	 * @author Joe Webster
	 * 
	 */
	public static class OpenSCManager extends SvcCtlCmd {

		public int getOpnum() {
			return SVC_OPEN_SC_MAN;
		}

		public String machine_name;
		public String database_name;

		public OpenSCManager(String machine_name, String database_name,
				int access_mask, rpc.policy_handle handle) {
			this.machine_name = machine_name;
			this.database_name = database_name;
			this.access_mask = access_mask;
			this.handle = handle;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.enc_ndr_referent(machine_name, 1);
			if (machine_name != null) {
				_dst.enc_ndr_string(machine_name);

			}
			_dst.enc_ndr_referent(database_name, 1);
			if (database_name != null) {
				_dst.enc_ndr_string(database_name);

			}
			_dst.enc_ndr_long(access_mask);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			handle.decode(_ndr, _src);
			retval = (int) _src.dec_ndr_long();
		}
	}

	/**
	 * Open Service class
	 * 
	 * Properties:
	 * 
	 * scmanager_handle - handle to the service control manager database. The
	 * OpenSCManager function returns this handle.
	 * 
	 * service_name - The name of the service to be opened. The maximum string
	 * length is 256 characters. The service control manager database preserves
	 * the case of the characters, but service name comparisons are always case
	 * insensitive. Forward-slash (/) and backslash (\) are invalid service name
	 * characters.
	 * 
	 * @author Joe Webster
	 * 
	 */
	public static class OpenService extends SvcCtlCmd {

		public int getOpnum() {
			return SVC_OPEN_SERVICE;
		}

		public rpc.policy_handle scmanager_handle;
		public String service_name;

		public OpenService(rpc.policy_handle scmanager_handle,
				String service_name, int access_mask, rpc.policy_handle handle) {
			this.scmanager_handle = scmanager_handle;
			this.service_name = service_name;
			this.access_mask = access_mask;
			this.handle = handle;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			scmanager_handle.encode(_ndr, _dst);
			_dst.enc_ndr_string(service_name);
			_dst.enc_ndr_long(access_mask);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			handle.decode(_ndr, _src);
			retval = (int) _src.dec_ndr_long();
		}
	}

	/**
	 * Query a service configuration class
	 * 
	 * Properties:
	 * 
	 * query - buffer that receives the service configuration information. The
	 * format of the data is a QUERY_SERVICE_CONFIG structure. The maximum size
	 * of this array is 8K bytes. To determine the required size, specify NULL
	 * for this parameter and 0 for the buf_size parameter. The function will
	 * fail and GetLastError will return ERROR_INSUFFICIENT_BUFFER. The
	 * bytes_needed parameter will receive the required size.
	 * 
	 * buf_size - the size of the buffer pointed to by the query parameter, in
	 * bytes.
	 * 
	 * bytes_needed - pointer to a variable that receives the number of bytes
	 * needed to store all the configuration information, if the function fails
	 * with ERROR_INSUFFICIENT_BUFFER.
	 * 
	 * @author Joe Webster
	 * 
	 */
	public static class QueryServiceConfig extends SvcCtlCmd {

		public int getOpnum() {
			return SVC_QUERY_SVC_CONFIG;
		}

		public byte[] query;
		public int buf_size;
		public int bytes_needed;

		public QueryServiceConfig(rpc.policy_handle handle, byte[] query,
				int buf_size, int bytes_needed) {
			this.handle = handle;
			this.query = query;
			this.buf_size = buf_size;
			this.bytes_needed = bytes_needed;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			handle.encode(_ndr, _dst);
			_dst.enc_ndr_long(buf_size);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			int _querys = _src.buf.length - 8;
			int _queryi = _src.index;
			_src.advance(1 * _querys);
			if (query == null) {
				if (_querys < 0 || _querys > 0xFFFF)
					throw new NdrException(NdrException.INVALID_CONFORMANCE);
				query = new byte[_querys];
			}
			_src = _src.derive(_queryi);
			for (int _i = 0; _i < _querys; _i++) {
				query[_i] = (byte) _src.dec_ndr_small();
			}
			bytes_needed = (int) _src.dec_ndr_long();
			retval = (int) _src.dec_ndr_long();
		}
	}

	/**
	 * Enumerate Services status class
	 * 
	 * Properties:
	 * 
	 * type - The type of services to be enumerated. This parameter can be one
	 * or more of the following values: SERVICE_DRIVER 0x0000000B Enumerates
	 * services of type SERVICE_KERNEL_DRIVER and SERVICE_FILE_SYSTEM_DRIVER.
	 * SERVICE_WIN32 0x00000030 Enumerates services of type
	 * SERVICE_WIN32_OWN_PROCESS and SERVICE_WIN32_SHARE_PROCESS.
	 * 
	 * state - The state of the services to be enumerated. This parameter can be
	 * one of the following values: SERVICE_ACTIVE 0x00000001 Enumerates
	 * services that are in the following states: SERVICE_START_PENDING,
	 * SERVICE_STOP_PENDING, SERVICE_RUNNING, SERVICE_CONTINUE_PENDING,
	 * SERVICE_PAUSE_PENDING, and SERVICE_PAUSED. SERVICE_INACTIVE 0x00000002
	 * Enumerates services that are in the SERVICE_STOPPED state.
	 * SERVICE_STATE_ALL 0x00000003 Combines the following states:
	 * SERVICE_ACTIVE and SERVICE_INACTIVE.
	 * 
	 * service - buffer that contains an array of ENUM_SERVICE_STATUS structures
	 * that receive the name and service status information for each service in
	 * the database. The buffer must be large enough to hold the structures,
	 * plus the strings to which their members point. The maximum size of this
	 * array is 256K bytes. To determine the required size, specify NULL for
	 * this parameter and 0 for the cbBufSize parameter. The function will fail
	 * and GetLastError will return ERROR_INSUFFICIENT_BUFFER. The bytes_needed
	 * parameter will receive the required size. Windows Server 2003 and Windows
	 * XP: The maximum size of this array is 64K bytes. This limit was increased
	 * as of Windows Server 2003 SP1 and Windows XP SP2.
	 * 
	 * buf_size - The size of the buffer pointed to by the service parameter, in
	 * bytes.
	 * 
	 * bytes_needed - The number of bytes needed to return the remaining service
	 * entries, if the buffer is too small.
	 * 
	 * services_returned - The number of service entries returned.
	 * 
	 * resume_handle - A pointer to a variable that, on input, specifies the
	 * starting point of enumeration. You must set this value to zero the first
	 * time this function is called. On output, this value is zero if the
	 * function succeeds. However, if the function returns zero and the
	 * GetLastError function returns ERROR_MORE_DATA, this value is used to
	 * indicate the next service entry to be read when the function is called to
	 * retrieve the additional data.
	 * 
	 * @author Joe Webster
	 * 
	 */
	public static class EnumServicesStatus extends SvcCtlCmd {

		public int getOpnum() {
			return SVC_ENUM_SVCS_STATUS;
		}

		public int type;
		public int state;
		public int buf_size;
		public byte[] service;
		public int bytes_needed;
		public int services_returned;
		public int resume_handle;

		public EnumServicesStatus(rpc.policy_handle handle, int type,
				int state, int buf_size, byte[] service, int bytes_needed,
				int services_returned, int resume_handle) {
			this.handle = handle;
			this.type = type;
			this.state = state;
			this.buf_size = buf_size;
			this.service = service;
			this.bytes_needed = bytes_needed;
			this.services_returned = services_returned;
			this.resume_handle = resume_handle;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			handle.encode(_ndr, _dst);
			_dst.enc_ndr_long(type);
			_dst.enc_ndr_long(state);
			_dst.enc_ndr_long(buf_size);
			_dst.enc_ndr_long(resume_handle);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			int _services = _src.dec_ndr_long();
			int _servicei = _src.index;
			_src.advance(1 * _services);
			if (service == null) {
				if (_services < 0 || _services > 0xFFFF)
					throw new NdrException(NdrException.INVALID_CONFORMANCE);
				service = new byte[_services];
			}
			_src = _src.derive(_servicei);
			for (int _i = 0; _i < _services; _i++) {
				service[_i] = (byte) _src.dec_ndr_small();
			}
			bytes_needed = (int) _src.dec_ndr_long();
			services_returned = (int) _src.dec_ndr_long();
			resume_handle = (int) _src.dec_ndr_long();
			retval = (int) _src.dec_ndr_long();
		}
	}

	/**
	 * Start a service class
	 * 
	 * Properties:
	 * 
	 * num_service_args - The number of strings in the service_arg_vectors
	 * array. If service_arg_vectors is NULL, this parameter can be zero.
	 * 
	 * service_arg_vectors - The null-terminated strings to be passed to the
	 * ServiceMain function for the service as arguments. If there are no
	 * arguments, this parameter can be NULL. Otherwise, the first argument
	 * (service_arg_vectors[0]) is the name of the service, followed by any
	 * additional arguments (service_arg_vectors[1] through
	 * service_arg_vectors[num_service_args-1]). Driver services do not receive
	 * these arguments.
	 * 
	 * @author Joe Webster
	 * 
	 */
	public static class StartService extends SvcCtlCmd {

		public int getOpnum() {
			return SVC_START_SERVICE;
		}

		public int num_service_args;

		public String[] service_arg_vectors;

		public StartService(rpc.policy_handle handle, int num_service_args,
				String[] service_arg_vectors) {
			this.handle = handle;
			this.num_service_args = num_service_args;
			this.service_arg_vectors = service_arg_vectors;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			handle.encode(_ndr, _dst);
			_dst.enc_ndr_long(num_service_args);
			_dst.enc_ndr_referent(service_arg_vectors, 1);
			if (service_arg_vectors != null) {
				int _service_arg_vectorss = num_service_args;
				_dst.enc_ndr_long(_service_arg_vectorss);
				for (int _i = 0; _i < _service_arg_vectorss; _i++) {
					_dst.enc_ndr_referent(service_arg_vectors[_i], 1);
				}

				for (int _i = 0; _i < _service_arg_vectorss; _i++) {
					if (service_arg_vectors[_i] != null) {
						_dst.enc_ndr_string(service_arg_vectors[_i]);

					}
				}
			}
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			retval = (int) _src.dec_ndr_long();
		}
	}

	public static class service_status extends SvcCtlCmd {

		public int service_type;
		public int current_state;
		public int controls_accepted;
		public int win32_exit_code;
		public int service_specific_exit_code;
		public int check_point;
		public int wait_hint;

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			_dst.align(4);
			_dst.enc_ndr_long(service_type);
			_dst.enc_ndr_long(current_state);
			_dst.enc_ndr_long(controls_accepted);
			_dst.enc_ndr_long(win32_exit_code);
			_dst.enc_ndr_long(service_specific_exit_code);
			_dst.enc_ndr_long(check_point);
			_dst.enc_ndr_long(wait_hint);

		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			_src.align(4);
			service_type = (int) _src.dec_ndr_long();
			current_state = (int) _src.dec_ndr_long();
			controls_accepted = (int) _src.dec_ndr_long();
			win32_exit_code = (int) _src.dec_ndr_long();
			service_specific_exit_code = (int) _src.dec_ndr_long();
			check_point = (int) _src.dec_ndr_long();
			wait_hint = (int) _src.dec_ndr_long();

		}
	}

	/**
	 * Control Service class
	 * 
	 * Properties:
	 * 
	 * control - This parameter can be one of the following control codes:
	 * 
	 * SERVICE_CONTROL_CONTINUE 0x00000003 Notifies a paused service that it
	 * should resume. The hService handle must have the SERVICE_PAUSE_CONTINUE
	 * access right.
	 * 
	 * SERVICE_CONTROL_INTERROGATE 0x00000004 Notifies a service that it should
	 * report its current status information to the service control manager. The
	 * hService handle must have the SERVICE_INTERROGATE access right. Note that
	 * this control is not generally useful as the SCM is aware of the current
	 * state of the service.
	 * 
	 * SERVICE_CONTROL_NETBINDADD 0x00000007 Notifies a network service that
	 * there is a new component for binding. The hService handle must have the
	 * SERVICE_PAUSE_CONTINUE access right. However, this control code has been
	 * deprecated; use Plug and Play functionality instead. Windows NT - This
	 * value is not supported.
	 * 
	 * SERVICE_CONTROL_NETBINDDISABLE 0x0000000A Notifies a network service that
	 * one of its bindings has been disabled. The hService handle must have the
	 * SERVICE_PAUSE_CONTINUE access right. However, this control code has been
	 * deprecated; use Plug and Play functionality instead. Windows NT - This
	 * value is not supported.
	 * 
	 * SERVICE_CONTROL_NETBINDENABLE 0x00000009 Notifies a network service that
	 * a disabled binding has been enabled. The hService handle must have the
	 * SERVICE_PAUSE_CONTINUE access right. However, this control code has been
	 * deprecated; use Plug and Play functionality instead. Windows NT - This
	 * value is not supported.
	 * 
	 * SERVICE_CONTROL_NETBINDREMOVE 0x00000008 Notifies a network service that
	 * a component for binding has been removed. The hService handle must have
	 * the SERVICE_PAUSE_CONTINUE access right. However, this control code has
	 * been deprecated; use Plug and Play functionality instead. Windows NT -
	 * This value is not supported.
	 * 
	 * SERVICE_CONTROL_PARAMCHANGE 0x00000006 Notifies a service that its
	 * startup parameters have changed. The hService handle must have the
	 * SERVICE_PAUSE_CONTINUE access right. Windows NT - This value is not
	 * supported.
	 * 
	 * SERVICE_CONTROL_PAUSE 0x00000002 Notifies a service that it should pause.
	 * The hService handle must have the SERVICE_PAUSE_CONTINUE access right.
	 * 
	 * SERVICE_CONTROL_STOP 0x00000001 Notifies a service that it should stop.
	 * The hService handle must have the SERVICE_STOP access right. After
	 * sending the stop request to a service, you should not send other controls
	 * to the service.
	 * 
	 * status - A pointer to a SERVICE_STATUS structure that receives the latest
	 * service status information. The information returned reflects the most
	 * recent status that the service reported to the service control manager.
	 * The service control manager fills in the structure only when
	 * ControlService returns one of the following error codes: NO_ERROR,
	 * ERROR_INVALID_SERVICE_CONTROL, ERROR_SERVICE_CANNOT_ACCEPT_CTRL, or
	 * ERROR_SERVICE_NOT_ACTIVE. Otherwise, the structure is not filled in.
	 * 
	 * @author Joe Webster
	 * 
	 */
	public static class ControlService extends SvcCtlCmd {

		public int getOpnum() {
			return SVC_CONTROL_SERVICE;
		}

		public int control;

		public service_status status;

		public ControlService(rpc.policy_handle handle, int control,
				service_status status) {
			this.handle = handle;
			this.control = control;
			this.status = status;
		}

		public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
				throws NdrException {
			handle.encode(_ndr, _dst);
			_dst.enc_ndr_long(control);
		}

		public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
				throws NdrException {
			status.decode(_ndr, _src);
			retval = (int) _src.dec_ndr_long();
		}
	}
}
