/**
 * Jarapac DCE/RPC Framework
 * 
 * Copyright (C) 2008 StillSecure www.stillsecure.com
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * Class: wkssvc.java
 * 
 * Author: Joe Webster
 * 
 * Description: provides wkssvc (Lanman Workstation Service) services.
 * 
 */
package msrpc;

import rpc.*;
import ndr.*;

/**
 * This class was originally generated via the midlc compiler from IDL code
 * provided with Jarapac and Samba 4.0.0tp4. It has been significantly altered
 * for for this implementation.
 * 
 * @author Joe Webster
 * 
 */
public class wkssvc extends Stub {

    /**
     * wkssvc pipe
     */
    public static final int WKS_GETINFO = 0x00;
    public static final int WKS_SETINFO = 0x01;
    public static final int WKS_ENUMUSERS = 0x02;
    public static final int WKS_USERGETINFO = 0x03;
    public static final int WKS_USERSETINFO = 0x04;
    public static final int WKS_TRANSPORTENUM = 0x05;
    public static final int WKS_TRANSPORTADD = 0x06;
    public static final int WKS_TRANSPORTDEL = 0x07;
    public static final int WKS_USEADD = 0x08;
    public static final int WKS_USEGETINFO = 0x09;
    public static final int WKS_USEDEL = 0x0a;
    public static final int WKS_USEENUM = 0x0b;
    public static final int WKS_MESSAGEBUFFERSEND = 0x0c;
    public static final int WKS_WKSSTATISTICSGET = 0x0d;
    public static final int WKS_LOGONDOMAINNAMEADD = 0x0e;
    public static final int WKS_LOGONDOMAINNAMEDEL = 0x0f;
    public static final int WKS_JOINDOMAIN = 0x10;
    public static final int WKS_UNJOINDOMAIN = 0x11;
    public static final int WKS_RENAMEMACHINEINDOMAIN = 0x12;
    public static final int WKS_VALIDATENAME = 0x13;
    public static final int WKS_GETJOININFORMATION = 0x14;
    public static final int WKS_GETJOINABLEOUS = 0x15;
    public static final int WKS_ENUMERATECOMPUTERNAMES = 0x1e;

    /**
     * wkssvc join flags
     */
    // TRUE: defer setting the SPN and dNSHostName until a rename operation
    public static final int WKS_JOIN_FLAGS_DEFER_SPN = 0x00000100;
    // TRUE: set the machine password to the provided one after the join
    // completes
    public static final int WKS_JOIN_FLAGS_MACHINE_PWD_PASSED = 0x00000080;
    // TRUE: perform an unsecured join
    public static final int WKS_JOIN_FLAGS_JOIN_UNSECURE = 0x00000040;
    // TRUE: allow the join to complete even if the account already exists
    public static final int WKS_JOIN_FLAGS_DOMAIN_JOIN_IF_JOINED = 0x00000020;
    // TRUE: this join is part of a w9x upgrade
    public static final int WKS_JOIN_FLAGS_WIN9X_UPGRADE = 0x00000010;
    // TRUE: delete the account when the domain is left
    public static final int WKS_JOIN_FLAGS_ACCOUNT_DELETE = 0x00000004;
    // TRUE: create the account in the domain
    public static final int WKS_JOIN_FLAGS_ACCOUNT_CREATE = 0x00000002;
    // TRUE: join domain FALSE: join workgroup
    public static final int WKS_JOIN_FLAGS_JOIN_TYPE = 0x00000001;

    public static final String MY_SYNTAX = "6bffd098-a112-3610-9833-46c3f87e345a:1.0";

    public String getSyntax() {
        return MY_SYNTAX;
    }

    /**
     * Workstation services TransportInfo0 data class
     * 
     * Properties:
     * 
     * qos - value that determines the search order of the transport protocol
     * with respect to other transport protocols. The highest value is searched
     * first.
     * 
     * vcs - number of clients communicating with the server using this
     * transport protocol.
     * 
     * name - device name of the transport protocol.
     * 
     * addr - address of the server on this transport protocol.
     * 
     * wan_ish - indicates whether the transport protocol is a WAN transport
     * protocol. This member is set to TRUE for NetBIOS/TCIP; it is set to FALSE
     * for NetBEUI and NetBIOS/IPX.
     * 
     * @author jwebster
     * 
     */
    public static class TransportInfo0 extends NdrObject {

        public int qos;
        public int vcs;
        public String name;
        public String addr;
        public int wan_ish;

        public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
                throws NdrException {
            _dst.align(4);
            _dst.enc_ndr_referent(name, 1);
            _dst.enc_ndr_referent(addr, 1);

            if (name != null) {
                _dst = _dst.deferred;
                _dst.enc_ndr_string(name);
            }
            if (addr != null) {
                _dst = _dst.deferred;
                _dst.enc_ndr_string(addr);
            }
        }

        public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
                throws NdrException {
            _src.align(4);
            qos = (int) _src.dec_ndr_long();
            vcs = (int) _src.dec_ndr_long();
            int _namep = _src.dec_ndr_long();
            int _addrp = _src.dec_ndr_long();
            wan_ish = (int) _src.dec_ndr_long();
            if (_namep != 0) {
                _src = _src.deferred;
                name = _src.dec_ndr_string();
            }
            if (_addrp != 0) {
                _src = _src.deferred;
                addr = _src.dec_ndr_string();
            }
        }
    }

    public static class TransportCtr0 extends NdrObject {

        public int count;
        public TransportInfo0[] array = null;

        public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
                throws NdrException {
            _dst.align(4);
            _dst.enc_ndr_long(count);
            _dst.enc_ndr_referent(array, 1);

            if (array != null) {
                _dst = _dst.deferred;
                int _arrays = count;
                _dst.enc_ndr_long(_arrays);
                int _arrayi = _dst.index;
                _dst.advance(20 * _arrays);

                _dst = _dst.derive(_arrayi);
                for (int _i = 0; _i < _arrays; _i++) {
                    array[_i].encode(_ndr, _dst);
                }
            }
        }

        public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
                throws NdrException {
            _src.align(4);
            count = (int) _src.dec_ndr_long();
            int _arrayp = _src.dec_ndr_long();

            if (_arrayp != 0) {
                _src = _src.deferred;
                int _arrays = _src.dec_ndr_long();
                int _arrayi = _src.index;
                _src.advance(20 * _arrays);

                if (array == null) {
                    if (_arrays < 0 || _arrays > 0xFFFF)
                        throw new NdrException(NdrException.INVALID_CONFORMANCE);
                    array = new TransportInfo0[_arrays];
                }
                _src = _src.derive(_arrayi);
                for (int _i = 0; _i < _arrays; _i++) {
                    if (array[_i] == null) {
                        array[_i] = new TransportInfo0();
                    }
                    array[_i].decode(_ndr, _src);
                }
            }
        }
    }

    public static abstract class WksCmd extends NdrObject {

        public int retval;
        public String servername;
        public int level;
        public NdrObject info;
    }

    /**
     * NetWkstaTransportEnum class
     * 
     * Supplies information about transport protocols that are managed by the
     * redirector, which is the software on the client computer that generates
     * file requests to the server computer.
     * 
     * Properties:
     * 
     * servername - specifies the DNS or NetBIOS name of the remote server on
     * which the function is to execute. If this parameter is NULL, the local
     * computer is used.
     * 
     * level - level of information requested for the data. This parameter can
     * be the following value: 0 Return workstation transport protocol
     * information. The bufptr parameter points to an array of
     * WKSTA_TRANSPORT_INFO_0 structures.
     * 
     * info -buffer that receives the data. The format of this data depends on
     * the value of the level parameter. This buffer is allocated by the system
     * and must be freed using the NetApiBufferFree function. Note that you must
     * free the buffer even if the function fails with ERROR_MORE_DATA or
     * NERR_BufTooSmall.
     * 
     * maxbuffer - maximum length of returned data, in bytes. If you specify
     * MAX_PREFERRED_LENGTH, the function allocates the amount of memory
     * required for the data. If you specify another value in this parameter, it
     * can restrict the number of bytes that the function returns. If the buffer
     * size is insufficient to hold all entries, the function returns
     * ERROR_MORE_DATA or NERR_BufTooSmall. For more information, see Network
     * Management Function Buffers and Network Management Function Buffer
     * Lengths.
     * 
     * totalentries - total number of entries that could have been enumerated
     * from the current resume position. Note that applications should consider
     * this value only as a hint.
     * 
     * resumehandle - resume handle which is used to continue an existing
     * workstation transport search. The handle should be zero on the first call
     * and left unchanged for subsequent calls. If the resumehandle parameter is
     * a NULL pointer, no resume handle is stored.
     * 
     * @author jwebster
     * 
     */
    public static class TransportEnum extends WksCmd {

        public int getOpnum() {
            return WKS_TRANSPORTENUM;
        }

        public int maxbuffer;
        public int totalentries;
        public int resume_handle;

        public TransportEnum(String servername,
                             int level,
                             NdrObject info,
                             int maxbuffer,
                             int totalentries,
                             int resume_handle) {
            this.servername = servername;
            this.level = level;
            this.info = info;
            this.maxbuffer = maxbuffer;
            this.totalentries = totalentries;
            this.resume_handle = resume_handle;
        }

        public void encode(NetworkDataRepresentation _ndr, NdrBuffer _dst)
                throws NdrException {
            _dst.enc_ndr_referent(servername, 1);
            if (servername != null) {
                _dst.enc_ndr_string(servername);
            }
            _dst.enc_ndr_long(level);
            int _descr = level;
            _dst.enc_ndr_long(_descr);
            _dst.enc_ndr_referent(info, 1);
            if (info != null) {
                _dst = _dst.deferred;
                info.encode(_ndr, _dst);
            }
            _dst.enc_ndr_long(maxbuffer);
            _dst.enc_ndr_long(resume_handle);
        }

        public void decode(NetworkDataRepresentation _ndr, NdrBuffer _src)
                throws NdrException {
            level = (int) _src.dec_ndr_long();
            _src.dec_ndr_long(); /* union discriminant */
            int _infop = _src.dec_ndr_long();
            if (_infop != 0) {
                if (info == null) {
                    info = new TransportCtr0();
                }
                _src = _src.deferred;
                info.decode(_ndr, _src);
            }
            totalentries = (int) _src.dec_ndr_long();
            resume_handle = (int) _src.dec_ndr_long();
            retval = (int) _src.dec_ndr_long();
        }
    }
}
